// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement1.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement1.m";
// 

// Bianchi group
Bianchi1<a,l,t,u> := Group<a,l,t,u|a^2,l^2,(t*l)^2,(u*l)^2,
                                   (a*l)^2,(t*a)^3,(u*a*l)^3,(t,u)>;
// Parabolic elements fixing cusp of the Bianchi orbifold
// Hack: also adding the rotation fixing the cusp
Bianchi1P := [[ t, u, l ]];

print "";
print "<2>";

VerifyLink(
    Bianchi1, Bianchi1P,
    [[2,0,2]], 48,
    [[ <Id(Bianchi1),  [ 1, 0]>,
       <a,             [ 0, 1]>,
       <t*a,           [ 1, 0]>,
       <u*a,           [ 1, 0]>,
       <u*t*a,         [ 0, 1]>,
       <a*u*t^-1*a^-1, [ 0, 1]>]]);

print "";
print "<2+sqrt(-1)>";

VerifyLink(
    Bianchi1, Bianchi1P,
    [[5,2,1]], 60,
    [[ <Id(Bianchi1),  [ 0, 1]>,
       <a,             [ 0, 1]>,
       <t^-1*a,        [ 0, 1]>,
       <t*a,           [ 0, 1]>,
       <t^-2*a,        [ 0, 1]>,
       <t^2*a,         [-1, 1]>]]);

print "";
print "<2+2*sqrt(-1)>";

VerifyLink(
    Bianchi1, Bianchi1P,
    [[4,2,2]], 192,
    [[ <Id(Bianchi1),     [ 0, 1]>,
       <a,                [-1, 1]>,
       <t^2*a,            [ 0, 1]>,
       <t*a,              [ 0, 1]>,
       <t^-1*a,           [ 0, 1]>,
       <u*a,              [ 0, 1]>,
       <u^-1*a,           [-1, 1]>,
       <t*u*a,            [-1, 2]>, 
       <t*u^-1*a,         [ 1, 0]>,
       <a*u*t^-1*a^-1,    [ 0, 1]>,
       <a*u^-1*t^-1*a^-1, [ 0, 1]>,
       <a*t^-2*a^-1,      [-1, 1]>]]);

print "";
print "<3>";

VerifyLink(
    Bianchi1, Bianchi1P,
    [[3,0,3]], 360,
    Symmetrize(
        a*t*u^-1, 5,
        [[]],
        [[ <Id(Bianchi1),  [ 1, 1]>,
           <t*a,           [ 1,-1]>,
           <t^-1*a,        [ 0, 1]>,
           <u^-1*t*a,      [ 0, 1]>]]));
    
print "";
print "<3+sqrt(-1)>";

h:=(t^5*a)^2;

VerifyLink(
    Bianchi1, Bianchi1P,
    [[10, 3,1]], 360,
    [[ <Id(Bianchi1),  [-1, 2]>,
       <h,             [ 0, 1]>,
       <h^2,           [ 0, 1]>,

       <a,             [-1, 2]>,
       <h*a,           [ 0, 1]>,
       <h^2*a,         [ 0, 1]>,

       <t^-1*a,        [ 0, 1]>,
       <h*t^-1*a,      [ 0, 1]>,
       <h^2*t^-1*a,    [ 0, 1]>,


       <t*a,           [ 0, 1]>,
       <h*t*a,         [ 0, 1]>,
       <h^2*t*a,       [ 0, 1]>,

       <t^-2*a,        [ 0, 1]>,
       <h*t^-2*a,      [ 0, 1]>,
       <h^2*t^-2*a,    [ 0, 1]>,

       <t^2*a,         [ 0, 1]>,
       <h*t^2*a,       [ 0, 1]>,
       <h^2*t^2*a,     [ 0, 1]>]]);

print "";
print "<3+2*sqrt(-1)>";

h:=u*a*u^-2*a*u^-1*t*a;

VerifyLink(
    Bianchi1, Bianchi1P,
    [[13,-5,1]], 1092,
    [[ <Id(Bianchi1), [ 0, 1]>,
       <h,            [ 1, 2]>,
       <h^2,          [ 1, 3]>,
       <a,            [ 1, 3]>,
       <h*a,          [ 1, 3]>,
       <h^2*a,        [ 1, 2]>,

       <t*a,          [ 1, 3]>,
       <t^2*a,        [ 1, 2]>,
       <t^3*a,        [ 1, 2]>,
       <t^4*a,        [ 1, 2]>,
       <t^5*a,        [ 1, 2]>,
       <t^6*a,        [ 1, 2]>,

       <t^-1*a,       [ 0, 1]>,
       <t^-2*a,       [ 1, 3]>,
       <t^-3*a,       [ 1, 3]>,
       <t^-4*a,       [ 1, 3]>,
       <t^-5*a,       [ 1, 2]>,
       <t^-6*a,       [ 1, 2]>,

       <t*h*a,        [ 1, 3]>,
       <t^2*h*a,      [ 1, 2]>,
       <t^3*h*a,      [ 1, 2]>,
       <t^4*h*a,      [ 1, 2]>,
       <t^5*h*a,      [ 1, 2]>,
       <t^6*h*a,      [ 1, 2]>,
       
       <t^-1*h*a,     [ 1, 2]>,
       <t^-2*h*a,     [ 1, 2]>,
       <t^-3*h*a,     [ 1, 2]>,
       <t^-4*h*a,     [ 1, 2]>,
       <t^-5*h*a,     [ 1, 2]>,
       <t^-6*h*a,     [ 1, 2]>,

       <t*h^2*a,      [ 1, 2]>,
       <t^2*h^2*a,    [ 1, 2]>,
       <t^3*h^2*a,    [ 1, 2]>,
       <t^4*h^2*a,    [ 1, 2]>,
       <t^5*h^2*a,    [ 1, 2]>,
       <t^6*h^2*a,    [ 1, 2]>,

       <t^-1*h^2*a,   [ 1, 2]>,
       <t^-2*h^2*a,   [ 1, 2]>,
       <t^-3*h^2*a,   [ 1, 2]>,
       <t^-4*h^2*a,   [ 1, 2]>,
       <t^-5*h^2*a,   [ 1, 2]>,
       <t^-6*h^2*a,   [ 1, 2]>]]);

print "";
print "<4+sqrt(-1)>";

h:=a*u*t^-1*a*t*u^2*a;

VerifyLink(
    Bianchi1, Bianchi1P,
    [[17,4,1]], 2448,
    [[ <Id(Bianchi1), [ 0, 1]>,
       <h,            [ 0, 1]>,
       <h^2,          [ 0, 1]>,
       <h^3,          [ 0, 1]>,
       <a,            [ 0, 1]>,
       <h*a,          [ 0, 1]>,
       <h^2*a,        [ 0, 1]>,
       <h^3*a,        [ 0, 1]>,
       
       <t*a,          [ 0, 1]>,
       <t^2*a,        [ 0, 1]>,
       <t^3*a,        [ 0, 1]>,
       <t^4*a,        [ 0, 1]>,
       <t^5*a,        [ 0, 1]>,
       <t^6*a,        [ 0, 1]>,
       <t^7*a,        [ 0, 1]>,
       <t^8*a,        [ 0, 1]>,

       <t^-1*a,       [ 0, 1]>,
       <t^-2*a,       [ 0, 1]>,
       <t^-3*a,       [ 0, 1]>,
       <t^-4*a,       [ 0, 1]>,
       <t^-5*a,       [ 0, 1]>,
       <t^-6*a,       [ 0, 1]>,
       <t^-7*a,       [ 0, 1]>,
       <t^-8*a,       [ 0, 1]>,
       
       <t*h*a,        [ 0, 1]>,
       <t^2*h*a,      [ 0, 1]>,
       <t^3*h*a,      [ 0, 1]>,
       <t^4*h*a,      [ 0, 1]>,
       <t^5*h*a,      [ 0, 1]>,
       <t^6*h*a,      [-1, 3]>,
       <t^7*h*a,      [ 0, 1]>,
       <t^8*h*a,      [-1, 4]>,

       <t^-1*h*a,     [ 0, 1]>,
       <t^-2*h*a,     [ 0, 1]>,
       <t^-3*h*a,     [ 0, 1]>,
       <t^-4*h*a,     [-1, 3]>,
       <t^-5*h*a,     [ 0, 1]>,
       <t^-6*h*a,     [ 0, 1]>,
       <t^-7*h*a,     [-1, 3]>,
       <t^-8*h*a,     [ 0, 1]>,

       <t*h^2*a,      [-1, 4]>,
       <t^2*h^2*a,    [ 0, 1]>,
       <t^3*h^2*a,    [ 0, 1]>,
       <t^4*h^2*a,    [ 0, 1]>,
       <t^5*h^2*a,    [-1, 3]>,
       <t^6*h^2*a,    [ 0, 1]>,
       <t^7*h^2*a,    [ 0, 1]>,
       <t^8*h^2*a,    [-1, 3]>,

       <t^-1*h^2*a,   [-1, 3]>,
       <t^-2*h^2*a,   [ 0, 1]>,
       <t^-3*h^2*a,   [ 0, 1]>,
       <t^-4*h^2*a,   [-1, 3]>,
       <t^-5*h^2*a,   [ 0, 1]>,
       <t^-6*h^2*a,   [ 0, 1]>,
       <t^-7*h^2*a,   [ 0, 1]>,
       <t^-8*h^2*a,   [ 0, 1]>,

       <t*h^3*a,      [ 0, 1]>,
       <t^2*h^3*a,    [ 0, 1]>,
       <t^3*h^3*a,    [ 0, 1]>,
       <t^4*h^3*a,    [-1, 3]>,
       <t^5*h^3*a,    [-1, 3]>,
       <t^6*h^3*a,    [-1, 3]>,
       <t^7*h^3*a,    [ 0, 1]>,
       <t^8*h^3*a,    [ 0, 1]>,

       <t^-1*h^3*a,   [-1, 3]>,
       <t^-2*h^3*a,   [-1, 4]>,
       <t^-3*h^3*a,   [-1, 4]>,
       <t^-4*h^3*a,   [-1, 3]>,
       <t^-5*h^3*a,   [ 0, 1]>,
       <t^-6*h^3*a,   [-1, 4]>,
       <t^-7*h^3*a,   [-1, 3]>,
       <t^-8*h^3*a,   [-1, 3]>]]);
