// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement11.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement11.m";
// 

Bianchi11<a,t,u> := Group<a,t,u|a^2,(t*a)^3,(a*t*u^-1*a*u)^3,(t,u)>;
Bianchi11P := [[ t, u ]];

print "";
print "<(1+sqrt(-11))/2>";

VerifyLink2(Bianchi11, Bianchi11P, [[ 0, 1]], 12);
    
print "";
print "<(3+sqrt(-11))/2>";

VerifyLink(
    Bianchi11, Bianchi11P,
    [[5,1,1]], 60,
    Symmetrize(
        a, 2,
        [[]],
        [[<Id(Bianchi11),    [ 0, 1]>,
          <t*a,              [ 0, 1]>,
          <t^2*a,            [-1, 2]>,
          
          <t^-2*a^-1,        [ 0, 1]>,
          <t*a*t^-2*a,       [ 0, 1]>,
          <t^2*a*t^-2*a^-1,  [ 0, 1]>]]));

print "";
print "<(5+sqrt(-11))/2>";

h:=t^-4*a*t^4;

VerifyLink(
    Bianchi11, Bianchi11P,
    [[9,2,1]], 324,
    [[<Id(Bianchi11),      [-1, 2]>,
      <a,                  [-1, 2]>,
      <h,                  [-1, 2]>,
      <a*h,                [ 0, 1]>,
      
      <t*a,                [ 0, 1]>,
      <a*t*a,              [ 0, 1]>,
      <h*t*a,              [-1, 2]>,
      <a*h*t*a,            [ 0, 1]>,
      
      <t^2*a,              [ 0, 1]>,
      <a*t^2*a,            [ 0, 1]>,
      <h*t^2*a,            [ 0, 1]>,
      <a*h*t^2*a,          [-1, 2]>,


      <t^-2*a,             [ 0, 1]>,
      <a*t^-2*a,           [ 0, 1]>,
      <h*t^-2*a,           [ 0, 1]>,
      <a*h*t^-2*a,         [ 0, 1]>,
      
      <t^3*a,              [ 0, 1]>,
      <a*t^3*a,            [ 0, 1]>,
      <h*t^3*a,            [ 1, 0]>,
      <a*h*t^3*a,          [ 0, 1]>,
      
      <t^-3*a,             [ 0, 1]>,
      <a*t^-3*a,           [ 0, 1]>,
      <h*t^-3*a,           [ 0, 1]>,
      <a*h*t^-3*a,         [ 0, 1]>,
      

      <t^-2*a*t^-2*a,      [-1, 2]>,
      <a*t^-2*a*t^-2*a,    [-1, 2]>,
      <h*t^-2*a*t^-2*a,    [ 0, 1]>,
      <a*h*t^-2*a*t^-2*a,  [ 0, 1]>,

      <t^2*a*t^-2*a,       [-1, 1]>,
      <a*t^2*a*t^-2*a,     [-1, 2]>,
      <h*t^2*a*t^-2*a,     [-1, 1]>,
      <a*h*t^2*a*t^-2*a,   [ 0, 1]>,
      
      <t^-3*a*t^-2*a,      [-1, 2]>,
      <a*t^-3*a*t^-2*a,    [-1, 2]>,
      <h*t^-3*a*t^-2*a,    [ 0, 1]>,
      <a*h*t^-3*a*t^-2*a,  [ 0, 1]>]]);
