// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement3.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement3.m";
// 

// Bianchi group
Bianchi3<a,l,t,u> := Group<a,l,t,u|(t,u),a^2,(a*l)^2,(t*a)^3,l^3,(u*a*l)^3,
                                   l^-1*t*l*u*t,l^-1*u*l*t^-1>;
// Parabolic elements fixing cusp of the Bianchi orbifold
// Hack: also adding the rotation fixing the cusp
Bianchi3P := [[ t, u, l ]];

print "";
print "<2>";

VerifyLink(
    Bianchi3, Bianchi3P,
    [[2,0,2]], 60,
    [[ <Id(Bianchi3),  [ 0, 1]>,
       <a,             [ 1, 0]>,
       <t*a,           [ 0, 1]>,
       <t*u*a,         [ 1, 0]>,
       <u*a,           [ 0, 1]> ]]);

print "";
print "<(5+sqrt(-3))/2>";

VerifyLink(
    Bianchi3, Bianchi3P,
    [[7,3,1]], 168,
    [[ <Id(Bianchi3),  [ 0, 1]>,
       <a,             [ 0, 1]>,
       <t*a,           [-1, 2]>,
       <t^2*a,         [ 0, 1]>,
       <t^3*a,         [ 0, 1]>,
       <t^-1*a,        [ 0, 1]>,
       <t^-2*a,        [ 0, 1]>,
       <t^-3*a,        [ 0, 1]> ]]);

print "";
print "<3>";

VerifyLink(
    Bianchi3, Bianchi3P,
    [[3,0,3]], 324,
    [[ <Id(Bianchi3),  [ 1, 0]>, 
       <a,             [ 1, 0]>, 
       <t*a,           [ 1, 0]>,
       <t^-1*a,        [ 0, 1]>, 
       <u*a,           [ 1, 0]>,  
       <u^-1*a,        [ 1, 0]>, 
       <t*u*a,         [ 0, 1]>, 
       <t^-1*u^-1*a,   [ 0, 1]>,
       <t^-1*u*a,      [ 0, 1]>, 
       <t*u^-1*a,      [ 0, 1]>,
       <a*t*u^-1*a,    [ 0, 1]>,
       <a*t^2*u*a,     [ 0, 1]>]]);

print "";
print "<3+sqrt(-3)>";

h:=t^2*a*t^-2*a*t^-2*a*t^2*a;
k:=u^2*a*u^2*a*u^-2*a*u^-2*a;


VerifyLink(
    Bianchi3, Bianchi3P,
    [[6,4,2]], 720,
    [[ <Id(Bianchi3),  [ 0, 1]>, 
       <h,             [ 0, 1]>,
       <k,             [ 0, 1]>,
       <h*k,           [ 0, 1]>,
       
       <a,             [-1, 1]>,
       <h*a,           [-1, 1]>,
       <k*a,           [-1, 1]>,
       <h*k*a,         [-1, 1]>,
       
       <t*a,           [ 0, 1]>,
       <h*t*a,         [ 0, 1]>,
       <k*t*a,         [ 0, 1]>,
       <h*k*t*a,       [ 0, 1]>,
       
       <t*u*a,         [ 0, 1]>,
       <h*t*u*a,       [ 0, 1]>,
       <k*t*u*a,       [ 0, 1]>,
       <h*k*t*u*a,     [ 0, 1]>,
       
       <u*a,           [ 1, 0]>,
       <h*u*a,         [ 1, 0]>,
       <k*u*a,         [ 1, 0]>,
       <h*k*u*a,       [-1, 1]>]]);

print "";
print "<(7+sqrt(-3))/2>";

h:=a*t^2*l*a*t^-2*a;

VerifyLink(
    Bianchi3, Bianchi3P,
    [[13,4,1]], 1092,
    [[ <Id(Bianchi3),  [-1, 2]>, 
       <h,             [ 0, 1]>,

       <t^-6*a,        [ 0, 1]>,
       <t^-5*a,        [ 0, 1]>,
       <t^-4*a,        [ 0, 1]>,
       <t^-3*a,        [ 0, 1]>,
       <t^-2*a,        [ 0, 1]>,
       <t^-1*a,        [ 0, 1]>,
       <a,             [ 0, 1]>,
       <t*a,           [ 0, 1]>,
       <t^2*a,         [ 0, 1]>,
       <t^3*a,         [ 0, 1]>,
       <t^4*a,         [ 0, 1]>,
       <t^5*a,         [ 0, 1]>,
       <t^6*a,         [ 0, 1]>,

       <t^-6*h*a,      [ 0, 1]>,
       <t^-5*h*a,      [-1, 3]>,
       <t^-4*h*a,      [ 0, 1]>,
       <t^-3*h*a,      [ 0, 1]>,
       <t^-2*h*a,      [ 0, 1]>,
       <t^-1*h*a,      [ 0, 1]>,
       <h*a,           [ 0, 1]>,
       <t*h*a,         [ 0, 1]>,
       <t^2*h*a,       [ 0, 1]>,
       <t^3*h*a,       [ 0, 1]>,
       <t^4*h*a,       [ 0, 1]>,
       <t^5*h*a,       [ 0, 1]>,
       <t^6*h*a,       [ 0, 1]> ]]);

print "";
print "<4+sqrt(-3)>";

h:=a*t^2*u*a*t^-2*a;

VerifyLink(
    Bianchi3, Bianchi3P,
    [[19,12,1]], 3420,
    [[<Id(Bianchi3),  [-1, 2]>,
      <h,             [-2, 3]>,
      <h^2,           [-1, 1]>,

      <t^-9*a,        [-2, 3]>,
      <t^-8*a,        [-2, 3]>,
      <t^-7*a,        [-2, 3]>,
      <t^-6*a,        [-2, 3]>,
      <t^-5*a,        [-2, 3]>,
      <t^-4*a,        [-2, 3]>,
      <t^-3*a,        [-2, 3]>,
      <t^-2*a,        [-2, 3]>,
      <t^-1*a,        [-2, 3]>,
      <a,             [-2, 3]>,
      <t*a,           [-2, 3]>,
      <t^2*a,         [-2, 3]>,
      <t^3*a,         [-2, 3]>,
      <t^4*a,         [-2, 3]>,
      <t^5*a,         [-2, 3]>,
      <t^6*a,         [-2, 3]>,
      <t^7*a,         [-2, 3]>,
      <t^8*a,         [-2, 3]>,
      <t^9*a,         [-2, 3]>,

      <t^-9*h*a,      [-3, 5]>,
      <t^-8*h*a,      [-3, 5]>,
      <t^-7*h*a,      [-1, 2]>,
      <t^-6*h*a,      [-1, 2]>,
      <t^-5*h*a,      [-1, 2]>,
      <t^-4*h*a,      [-1, 2]>,
      <t^-3*h*a,      [-2, 3]>,
      <t^-2*h*a,      [-1, 2]>,
      <t^-1*h*a,      [-1, 2]>,
      <h*a,           [-1, 2]>,
      <t*h*a,         [-1, 2]>,
      <t^2*h*a,       [-1, 2]>,
      <t^3*h*a,       [-1, 2]>,
      <t^4*h*a,       [-1, 2]>,
      <t^5*h*a,       [-3, 5]>,
      <t^6*h*a,       [-1, 2]>,
      <t^7*h*a,       [-1, 2]>,
      <t^8*h*a,       [-1, 2]>,
      <t^9*h*a,       [-1, 2]>,
      
      <t^-9*h^2*a,    [-1, 2]>,
      <t^-8*h^2*a,    [-3, 5]>,
      <t^-7*h^2*a,    [-1, 2]>,
      <t^-6*h^2*a,    [-3, 5]>,
      <t^-5*h^2*a,    [-2, 3]>,
      <t^-4*h^2*a,    [-1, 2]>,
      <t^-3*h^2*a,    [-1, 2]>,
      <t^-2*h^2*a,    [-1, 2]>,
      <t^-1*h^2*a,    [-1, 2]>,
      <h^2*a,         [-1, 2]>,
      <t*h^2*a,       [-1, 2]>,
      <t^2*h^2*a,     [-1, 2]>,
      <t^3*h^2*a,     [-2, 3]>,
      <t^4*h^2*a,     [-1, 2]>,
      <t^5*h^2*a,     [-1, 2]>,
      <t^6*h^2*a,     [-1, 2]>,
      <t^7*h^2*a,     [-1, 2]>,
      <t^8*h^2*a,     [-1, 2]>,
      <t^9*h^2*a,     [-1, 2]>]]);

print "";
print "<(9+sqrt(-3))/2>";

h:=a*l^2*t^2*u*a*t^2*a*t^-1*u^-1;
k:=a*t*a*t^-1*u^-1*a*l^2*t*u*a*t^-1;

VerifyLink(
    Bianchi3, Bianchi3P,
    [[21,5,1]], 4032,
    [[<Id(Bianchi3),   [-1, 3]>,
      <a,              [ 0, 1]>,
      <t*a,            [ 0, 1]>,
      <t^2*a,          [ 0, 1]>,
      
      <t^3*a,          [ 0, 1]>,
      <t^-1*a,         [ 0, 1]>,
      <t^-2*a,         [ 0, 1]>,
      <t^-3*a,         [ 0, 1]>,
      
      <h,              [ 0, 1]>,
      <h*a,            [ 0, 1]>,
      <h*t*a,          [ 0, 1]>,
      <h*t^2*a,        [ 0, 1]>,
      
      
      <h*t^3*a,        [ 0, 1]>,
      <h*t^-1*a,       [ 0, 1]>,
      <h*t^-2*a,       [ 0, 1]>,
      <h*t^-3*a,       [ 0, 1]>,
      
      <k,              [ 0, 1]>,
      <k*a,            [ 0, 1]>,
      <k*t*a,          [ 0, 1]>,
      <k*t^2*a,        [ 0, 1]>,
      
      <k*t^3*a,        [ 0, 1]>,
      <k*t^-1*a,       [ 0, 1]>,
      <k*t^-2*a,       [ 0, 1]>,
      <k*t^-3*a,       [ 0, 1]>,
      
      <k*h,            [ 0, 1]>,
      <k*h*a,          [ 0, 1]>,
      <k*h*t*a,        [ 0, 1]>,
      <k*h*t^2*a,      [ 0, 1]>,
      
      <k*h*t^3*a,      [ 0, 1]>,
      <k*h*t^-1*a,     [-1, 4]>,
      <k*h*t^-2*a,     [ 0, 1]>,
      <k*h*t^-3*a,     [ 0, 1]>,
      
      <k^2,            [ 0, 1]>,
      <k^2*a,          [ 0, 1]>,
      <k^2*t*a,        [ 0, 1]>,
      <k^2*t^2*a,      [ 0, 1]>,
      
      <k^2*t^-3*a,     [ 0, 1]>,
      <k^2*t^3*a,      [ 0, 1]>,
      <k^2*t^-1*a,     [ 0, 1]>,
      <k^2*t^-2*a,     [ 0, 1]>,
      
      <k^2*h,          [ 0, 1]>,
      <k^2*h*a,        [ 0, 1]>,
      <k^2*h*t*a,      [ 0, 1]>,
      <k^2*h*t^2*a,    [ 0, 1]>,
      
      
      <k^2*h*t^3*a,    [ 0, 1]>,
      <k^2*h*t^-1*a,   [ 0, 1]>,
      <k^2*h*t^-2*a,   [ 0, 1]>,
      <k^2*h*t^-3*a,   [ 0, 1]>,
      
      <k^-1,           [ 0, 1]>,
      <k^-1*a,         [ 0, 1]>,
      <k^-1*t*a,       [ 0, 1]>,
      <k^-1*t^2*a,     [ 0, 1]>,
      
      <k^-1*t^3*a,     [ 0, 1]>,
      <k^-1*t^-1*a,    [ 0, 1]>,
      <k^-1*t^-2*a,    [ 0, 1]>,
      <k^-1*t^-3*a,    [ 0, 1]>,
      
      <k^-1*h,         [-1, 2]>,
      <k^-1*h*a,       [ 1, 0]>,
      <k^-1*h*t*a,     [ 0, 1]>,
      <k^-1*h*t^2*a,   [ 0, 1]>,
      
      <k^-1*h*t^3*a,   [ 0, 1]>,
      <k^-1*h*t^-1*a,  [-1, 4]>,
      <k^-1*h*t^-2*a,  [ 0, 1]>,
      <k^-1*h*t^-3*a,  [ 0, 1]>]]);
