// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement47.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement47.m";
// 

Bianchi47<g1,g2,g3,g4,g5,g6,g7> := Group<g1,g2,g3,g4,g5,g6,g7|
    g1^3,(g3,g2),(g2^-1*g1)^2,(g5,g7),g2^-1*g1*g6*g1^-1*g2*g6^-1,
    g6*g2^-1*g4^-1*g5*g3^-1*g6^-1*g4*g2*g3*g5^-1,
    g7^-1*g2^-1*g5^-1*g4*g1*g4^-1*g2*g7*g4*g1^-1*g4^-1*g5,
    g3*g5^-1*g4*g1*g4^-1*g2*g5*g3^-1*g2^-1*g4^-1*g1^-1*g4,
    g5^-1*g4*g1*g4^-1*g7^-1*g2^-1*g4*g1^-1*g4^-1*g5*g3^-1*g2*g3*g7>;

Bianchi47P := [ [ g2, g3 ],
                [ g5, g7 ],
                [ g2*g7, g4*g1^-1*g4^-1*g5 ],
                [ g6*g2^-1*g4^-1, g5*g3^-1*g2^-1*g4^-1 ],
                [ g6^-1*g1^-1*g4, g3*g5^-1*g4*g1 ]];

print "";
print "<2, (1+sqrt(-47))/2>";

VerifyLink(
    Bianchi47, Bianchi47P,
    [[2,1,1], [2,1,1], [1,0,2], [1,0,2], [2,0,1]], 6,
    
    Expand([ g1^0, g1^1, g1^2 ],
           [ [ [ 1,-1], [ 0, 1], [ 0, 1] ],
             [ [ 0, 1], [ 0, 1], [ 0, 1] ],
             [ [ 1, 0], [ 1, 0], [ 1, 0] ],
             [ [ 1, 0], [ 1, 0], [ 1, 0] ],
             [ [ 0, 1], [ 0, 1], [ 0, 1] ]]));

print "";
print "<3, (1+sqrt(-47))/2>";

VerifyLink(
    Bianchi47, Bianchi47P,
    [[3,1,1], [1,0,3], [3,1,-1], [1,0,3], [3,1,1]], 12,

    Expand([ Id(Bianchi47), (g2^-1*g1),
             (g1*g2^-1),    (g2^-1*g1)*(g1*g2^-1) ],
           [ [ [ 0, 1], [-1, 1], [ 0, 1], [ 0, 1] ],
             [ [ 1, 0], [ 1, 0], [ 1, 0], [ 1, 0] ],
             [ [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1] ],
             [ [ 1, 0], [ 1, 0], [ 1, 0], [ 1, 0] ],
             [ [ 0, 1], [ 0, 1], [ 0, 1], [ 0, 1] ] ]));

print "";
print "<4, (1+sqrt(-47))/2>";

h:=g1^-1*g2^2*g1;

VerifyLink(
    Bianchi47, Bianchi47P,
    [[4,1,1], [4,1,1], [1,0,4], [2,1,2], [4,2,1]], 24,
    [[<Id(Bianchi47),  [-1, 1]>,
      <h,              [-1, 1]>,
      <g1,             [ 0, 1]>,
      <g1*h,           [-1, 1]>,
      <g1^-1,          [-1, 1]>,
      <g2^2*g1^-1,     [ 0, 1]>],
     [<Id(Bianchi47),  [ 0, 1]>,
      <h,              [ 0, 1]>,
      <g1,             [ 0, 1]>,
      <h*g1,           [ 0, 1]>,
      <g1^-1,          [ 0, 1]>,
      <g2^2*g1^-1,     [ 0, 1]>],
     [<Id(Bianchi47),  [ 1, 0]>,
      <h,              [ 1, 0]>,
      <g1,             [ 1, 0]>,
      <g1*h,           [ 1, 0]>,
      <g1^-1,          [ 1, 0]>,
      <h*g1^-1,        [ 1, 0]>],
     [<Id(Bianchi47),  [ 0, 1]>,
      <h,              [ 1, 0]>,
      <g1,             [-1, 1]>,
      <g2^2*g1,        [ 0, 1]>,
      <g1^-1,          [-1, 1]>,
      <h*g1^-1,        [-1, 1]>],
     [<Id(Bianchi47),  [ 0, 1]>,
      <g2^2,           [-1, 2]>,
      <g1,             [-1, 2]>,
      <h*g1,           [-1, 2]>,
      <g1^-1,          [ 1,-1]>,
      <h*g1^-1,        [-1, 2]>]]);
