// The entire file can be run from the shell with
//     magma LinkComplementHelpers.m LinkComplement71.m
// or from within magma with
//     load "LinkComplementHelpers.m";
//     load "LinkComplement71.m";
// 

Bianchi71<g1,g2,g3,g4,g5,g6,g7,g8,g9> := Group<g1,g2,g3,g4,g5,g6,g7,g8,g9 |
    g8^3,(g8^-1,g4),(g8*g7^-1)^2,g1^-1*g3*g7*g3^-1*g1*g7^-1,
    g6*g3*g6^-1*g7*g9^-1*g3^-1*g9*g7^-1,
    g7^-1*g6*g3*g6^-1*g5^-1*g2*g7*g5*g6*g3^-1*g6^-1*g2^-1,
    g8*g7^-1*g1*g5*g6*g3^-1*g1*g5*g7*g8^-1*g5^-1*g1^-1*g3*g6^-1*g5^-1*g1^-1,
    g4^-1*g7^-1*g5^-1*g2*g1^-1*g3*g7*g9*g4*g1*g7^-1*g2^-1*g5*g7*g9^-1*g3^-1,
    (g5*g8*g7^-1*g5^-1*g1^-1*g7*g9*g6*g1*g5*g8*g7^-1*
     g5^-1*g1^-1*g3*g6^-1*g9^-1*g7^-1*g3^-1*g1),
    (g2*g6*g1*g5*g7*g8^-1*g5^-1*g1^-1*g3*g6^-1*g7*g8^-1*g5^-1*
     g2^-1*g5*g7*g8^-1*g5^-1*g1^-1*g7*g8^-1*g1*g5*g6*g3^-1*g6^-1)>;

Bianchi71P := [
    [ g7, g1^-1*g3 ],
    [ g2, g6*g1*g5*g7*g8^-1*g5^-1*g1^-1*g3*g6^-1*g7*g8^-1*g5^-1 ],
    [ g3, g6^-1*g7*g9^-1 ], 
    [ g7*g2, g6*g3*g6^-1*g5^-1*g7^-1 ],
    [ g7*g9*g6, g3^-1*g1*g5*g8*g7^-1*g5^-1*g1^-1 ],
    [ g3*g9*g4, g4^-1*g7^-1*g5^-1*g2*g7*g1^-1 ],
    [ g4*g1*g7^-1*g2^-1*g5*g7*g9^-1*g3^-1*g8^-1*g4^-1,
      g6*g3^-1*g1*g5*g8*g7^-1*g5^-1*g1^-1*g6^-1*g9^-1*g8^-1*g4^-1 ]];
    
print "";
print "<2, (1+sqrt(-71))/2>";

VerifyLink(
    Bianchi71, Bianchi71P,
    [[2,1,1], [2,0,1], [2,1,1], [1,0,2], [2,0,1], [2,0,1], [2,0,1]], 6,
    
    Expand([ g8^0, g8^1, g8^2],
           [[ [ 0, 1], [ 1, 0], [ 1, 0] ],
            [ [ 0, 1], [ 0, 1], [ 0, 1] ],
            [ [ 0, 1], [ 0, 1], [ 0, 1] ],
            [ [ 1, 0], [ 1, 0], [ 1, 0] ],
            [ [ 0, 1], [ 0, 1], [ 0, 1] ],
            [ [ 0, 1], [ 0, 1], [ 0, 1] ],
            [ [ 0, 1], [ 0, 1], [ 0, 1] ]]));
