from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-39)
psi = Q.gen()
w = (1+psi)/2

g1 = matrix(Q, [[ 1, 1], [ 0, 1]])
g2 = matrix(Q, [[ 1, w], [ 0, 1]])
g3 = matrix(Q, [[ 0, 1], [-1, 1]])
g4 = matrix(Q, [[-3-w, 7-2*w], [2-w, 5+w]])
g5 = matrix(Q, [[ 3-w, 2+w], [3,-1+w]])
g6 = matrix(Q, [[ 7-w, 2+3*w], [2+w, -5+w]])
g7 = matrix(Q, [[ 6-w, -1+2*w], [1-2*w, 5+w]])

P = [ [ g1, g2 ],
      [ g4, g6 ],
      [ g5**-1 *g6, g4* g1**-1 *g6 ],
      [ g5, g4* g2**-1 *g7 ] ];

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        g3**3,Com(g4,g6),(g3*g5)**2,Com(g2,g1),(g1**-1*g3**-1)**2,Com(g3**-1,g7**-1),
        (g5**-1*g1)**3,g5**-1*g1*g6**-1*g4**-1*g5*g4*g1**-1*g6,
        g4**-1*g5*g4*g2**-1*g7*g5**-1*g7**-1*g2,(g7*g5**-1*g7**-1*g1)**3,
        g6*g1**-1*g5*g6**-1*g4**-1*g5*g4*g1**-1*g4**-1*g5*g4*g1**-1])
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,[[2,0,1], [2,0,1], [2,0,1], [2,-1,1]],     Q.ideal([ 2, ( 1+psi)/2]))
print areNklTriplesValid(P,[[3,1,1], [1,0,3], [3,2,1], [3,-1,1]],     Q.ideal([ 3, ( 3+psi)/2]))
print areNklTriplesValid(P,[[4,-2,1], [4,0,1], [4,0,1], [4,-1,1]],    Q.ideal([ 4, ( 3-psi)/2]))
print areNklTriplesValid(P,[[2,0,2], [2,0,2], [2,0,2], [2,0,2]],      Q.ideal([ 2 ]))
print areNklTriplesValid(P,[[5,0,1], [5,1,-1], [5,2,1], [5,1,1]],     Q.ideal([ 5, ( 1+psi)/2]))
print areNklTriplesValid(P,[[8,2,1], [8,4,1], [8,4,1], [8,3,1]],      Q.ideal([ 8, ( 5+psi)/2]))
print areNklTriplesValid(P,[[11,3,1], [11,-2,1], [11,3,1], [11,4,1]], Q.ideal([11, ( 7+psi)/2]))

