from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-5)
psi = Q.gen()
w = psi

a = matrix(Q,[[ 0,-1],[ 1, 0]])
t = matrix(Q,[[ 1, 1],[ 0, 1]])
u = matrix(Q,[[ 1, w],[ 0, 1]])
b = matrix(Q,[[-w,2],[2,w]])
c = matrix(Q,[[-w-4,-2*w],[2*w,w-4]])

P = [[ t, u ], [ t*b, t*u**-1*c*t**-1 ] ]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        Com(t,u), a**2, b**2, (t*a)**3, (a*b)**2,
        (a*u*b*u**-1)**2, a*c*a*t*c**-1*t**-1,
        u*b*u**-1*c*b*t*c**-1*t**-1])
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,2 * [[ 2, 1, 1]], Q.ideal([ 2, 1+psi]))
print areNklTriplesValid(P,2 * [[ 3, 1, 1]], Q.ideal([ 3, 1+psi]))
print areNklTriplesValid(P,2 * [[ 2, 0, 2]], Q.ideal([ 2 ]))
print areNklTriplesValid(P,2 * [[ 5, 0, 1]], Q.ideal([ psi ]))
print areNklTriplesValid(P,2 * [[ 6, 1, 1]], Q.ideal([ 1+psi ]))
print areNklTriplesValid(P,2 * [[ 7, 3, 1]], Q.ideal([ 7, 3+psi ]))
print areNklTriplesValid(P,2 * [[ 3, 0, 3]], Q.ideal([ 3 ]))
print areNklTriplesValid(P,2 * [[ 9,-2, 1]], Q.ideal([ 2-psi ]))
print areNklTriplesValid(P,2 * [[29,-13, 1]], Q.ideal([ 3+2*psi ]))
