from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-6)
psi = Q.gen()
w = psi

a = matrix(Q,[[ 0,-1],[ 1, 0]])
t = matrix(Q,[[ 1, 1],[ 0, 1]])
u = matrix(Q,[[ 1, w],[ 0, 1]])
b = matrix(Q,[[-1-w,2-w],[2,1+w]])
c = matrix(Q,[[5,-2*w],[2*w,5]])

P = [[ t, u ], [ t*b, u**-1 * c**-1 ]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([a**2,b**2,Com(t,u),(t*a)**3,Com(a,c),
                              t**-1*c*t*u*b*u**-1*c**-1*b**-1,
                              (a*t*b)**3,(a*t*u*b*u**-1)**3])
        
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,2 * [[ 2, 0, 1]], Q.ideal([ 2, psi]))
print areNklTriplesValid(P,2 * [[ 3, 0, 1]], Q.ideal([ 3, psi]))
print areNklTriplesValid(P,2 * [[ 2, 0, 2]], Q.ideal([ 2]))
print areNklTriplesValid(P,2 * [[ 5, 2, 1]], Q.ideal([ 5, 2+psi]))
print areNklTriplesValid(P,2 * [[ 7, 1, 1]], Q.ideal([ 1+psi]))
print areNklTriplesValid(P,2 * [[11, 4, 1]], Q.ideal([11, 4+psi]))
print areNklTriplesValid(P,2 * [[31, 5, 1]], Q.ideal([ 5+psi]))
