from checkMatricesAndPeripheralsHelpers import *

Q = QuadraticField(-71)
psi = Q.gen()
w = (1+psi)/2

g1 = matrix(Q, [[-5, 5-3*w], [-1+w, -10-w]])
g2 = matrix(Q, [[-3+2*w, -17-w], [ -4, 1-2*w]])
g3 = matrix(Q, [[5, -2*w], [1-w, -7]])
g4 = matrix(Q, [[-5, 2+w], [-2-w, -3+w]])
g5 = matrix(Q, [[-6-3*w, 13-2*w], [5-w, 4+w]])
g6 = matrix(Q, [[-1+2*w, 12], [-6, -1+2*w]])
g7 = matrix(Q, [[1,-1], [0,1]])
g8 = matrix(Q, [[0,-1], [1,-1]])
g9 = matrix(Q, [[1+w, -7], [3, -2+w]])

P = [ [ g7, g1**-1*g3 ],
      [ g2, g6*g1*g5*g7*g8**-1*g5**-1*g1**-1*g3*g6**-1*g7*g8**-1*g5**-1 ],
      [ g3, g6**-1*g7*g9**-1 ], 
      [ g7*g2, g6*g3*g6**-1*g5**-1*g7**-1 ],
      [ g7*g9*g6, g3**-1*g1*g5*g8*g7**-1*g5**-1*g1**-1 ],
      [ g3*g9*g4, g4**-1*g7**-1*g5**-1*g2*g7*g1**-1 ],
      [ g4*g1*g7**-1*g2**-1*g5*g7*g9**-1*g3**-1*g8**-1*g4**-1,
        g6*g3**-1*g1*g5*g8*g7**-1*g5**-1*g1**-1*g6**-1*g9**-1*g8**-1*g4**-1 ]]

# Check that we didn't do any mistakes typing in the matrices or
# peripheral elements by checking against the relations and checking
# that the given matrices for P are parabolic.
ensurePslMatricesAreIdentity([
        g8**3,Com(g8**-1,g4),(g8*g7**-1)**2,g1**-1*g3*g7*g3**-1*g1*g7**-1,
        g6*g3*g6**-1*g7*g9**-1*g3**-1*g9*g7**-1,
        g7**-1*g6*g3*g6**-1*g5**-1*g2*g7*g5*g6*g3**-1*g6**-1*g2**-1,
        g8*g7**-1*g1*g5*g6*g3**-1*g1*g5*g7*g8**-1*g5**-1*g1**-1*g3*g6**-1*g5**-1*g1**-1,
        g4**-1*g7**-1*g5**-1*g2*g1**-1*g3*g7*g9*g4*g1*g7**-1*g2**-1*g5*g7*g9**-1*g3**-1,
        (g5*g8*g7**-1*g5**-1*g1**-1*g7*g9*g6*g1*g5*g8*g7**-1*
         g5**-1*g1**-1*g3*g6**-1*g9**-1*g7**-1*g3**-1*g1),
        (g2*g6*g1*g5*g7*g8**-1*g5**-1*g1**-1*g3*g6**-1*g7*g8**-1*g5**-1*
         g2**-1*g5*g7*g8**-1*g5**-1*g1**-1*g7*g8**-1*g1*g5*g6*g3**-1*g6**-1)])
ensurePslMatricesAreParabolic(P)

print areNklTriplesValid(P,[[2,1,1], [2,0,1], [2,1,1], [1,0,2], [2,0,1], [2,0,1], [2,0,1]],
                     Q.ideal([2, (1+psi)/2]))
print areNklTriplesValid(P,[[3,1,1], [3,-1,1], [3,0,1], [3,0,1], [3,1,1], [3,1,1], [3,0,1]],
                     Q.ideal([3, (1+psi)/2]))
print areNklTriplesValid(P,[[4,-1,1], [4,2,1], [4,1,1], [1,0,4], [4,2,1], [4,0,1], [4,2,-1]],
                     Q.ideal([4, (3-psi)/2]))
print areNklTriplesValid(P,[[2,0,2], [2,0,2], [2,0,2], [2,0,2], [2,0,2], [2,0,2], [2,0,2]],
                     Q.ideal([2]))
print areNklTriplesValid(P,[[5,2,1], [5,-1,1], [5,2,-1], [5,1,1], [5,-1,1], [5,2,1], [5,2,1]],
                     Q.ideal([5, (3+psi)/2]))
print areNklTriplesValid(P,[[19,5,1], [19,9,1], [19,2,1], [19,3,-1], [19,8,-1], [19,8,1], [19,5,-1]],
                     Q.ideal([19, (9+psi)/2]))
