from sage.all import *

def slMatrixIsIdentityModIdeal(m, I):
    return all([(entry in I)
                for row in (m - matrix.identity(2))
                for entry in row])

def pslMatrixIsIdentityModIdeal(m, I):
    return (slMatrixIsIdentityModIdeal( m, I) or
            slMatrixIsIdentityModIdeal(-m, I))

def ensurePslMatricesAreIdentity(ms):
    i = matrix.identity(2)
    for m in ms:
        if not (m == i or m == -i):
            raise Exception("Matrix not identity")

def ensurePslMatricesAreParabolic(P):
    for ps in P:
        for p in ps:
            if not p.det() == 1:
                raise Exception("Determinant not 1")
            if not (p.trace() == 2 or p.trace() == -2):
                raise Excetpion("Trace not +-2")

def isNklTripleValid(P, nkl, I):
    n,k,l = nkl
    if l < 0:
        k, l = -k, -l
    if not pslMatrixIsIdentityModIdeal(P[0]**n, I):
        return False
    if not pslMatrixIsIdentityModIdeal(P[0]**k * P[1]**l, I):
        return False
    for t in range(l):
        min_s = -((-t*k)//l) # ceil(t*k/l)
        max_s = min_s + abs(n)
        for s in range(min_s, max_s):
            if s != 0 or t != 0:
                if pslMatrixIsIdentityModIdeal(P[0]**s * P[1]**t, I):
                    return False
    return True

def areNklTriplesValid(Ps, nkls, I):
    return all([isNklTripleValid(P, nkl, I) for P, nkl in zip(Ps, nkls)])

def Com(a,b):
    return a*b*a**-1*b**-1
