import regina

from trigUtils import *
from trigUtils.edgeCollapsing import *

import os, sys

usage = """Usage: python collapseEdgesReginaTrig.py TRIANGULATION.rga
   or: sage -python collapseEdgesReginaTrig.py TRIANGULATION.rga

Collapse edges for as long as it does not change the topology.
"""

if __name__ == '__main__':
    if len(sys.argv) != 2:
        print usage
        sys.exit(1)

    sys.setrecursionlimit(100000)


    name, ext = os.path.splitext(sys.argv[1])

    with TimingMeasurement("total"):

        with TimingMeasurement("opening regina triangulation"):
            T = regina.open(sys.argv[1])
            
        with TimingMeasurement("collapsing edges"):
            numTets = T.countTetrahedra()
            T = EdgeCollapsingEngine.reginaTrigCollapsedEdges(T)

        outfile = name
        if not '__' in outfile:
            outfile += '_'
        outfile += '_collapsedEdges.rga'

        with TimingMeasurement("saving regina triangulation"):
            T.save(outfile)

    print "Saved result as:", outfile
    print "Number of tetrahedra: %d -> %d" % (numTets, T.countTetrahedra())

