from snappy import Triangulation

import sys, os

from trigUtils import *
from trigUtils.formatting import *

usage = """Usage: python homologySnapPyTriangulation.py TRIANGULATION.tri
   or: sage -python homologySnapPyTriangulation.py TRIANGULATION.tri

Uses SnapPy to compute the homology of the given triangulation.
"""

if __name__ == '__main__':
    if len(sys.argv) != 2:
        print usage
        sys.exit(1)

    name, ext = os.path.splitext(sys.argv[1])

    with TimingMeasurement("total"):
        with TimingMeasurement("reading SnapPy triangulation"):
            T = Triangulation(sys.argv[1])

        with TimingMeasurement("computing homology"):
            H = T.homology()

    outfile = name.split('__')[0] + '.homology'

    result = formatHomology(H) + formatSnapPyStatistics(T)
    open(outfile, 'w').write(result)

    print "Saved result as:", outfile
    
