# Copyright 2017 by Matthias Goerner, enischte@gmail.com.
#
# This code is released under the `GNU General Public License, version 2
# <http://www.gnu.org/licenses/gpl-2.0.txt>`_ or (at your option) any
# later version as published by the Free Software Foundation.

"""
A library to create principal congruence manifolds.
"""

from bianchiOrbifold import loadBianchiOrbifold

from .principalCongruenceManifoldGenerator import *

def generatePrincipalCongruenceManifold(ideal, is_gamma1 = False):
    """
    Returns a regina triangulation for the (principal) congruence manifold
    using the Bianchi orbifold stored in the data directory.

    D has to be a square-free positive Sage Integer. a and b have to be
    Sage Integer/Rational's.

    See PrincipalCongruenceManifoldGenerator for details.
    """

    r = loadBianchiOrbifold(ideal.D)
    return PrincipalCongruenceManifoldGenerator(r, ideal, is_gamma1 = is_gamma1)

